debug = true

spawnEnemyPauseMax = 1.1 
spawnEnemyPause = spawnEnemyPauseMax

player = { x = 0, y = 0, tempo = 175, picture = nil }
isAlive = true
score  = 0

picture = nil

enemyZoom = 0.35

allEnemies = {} 

enemyTempo = 220

gamestate = "Menu"

bg01 = love.graphics.newImage('klangbilder/Boden.png')
bg02 = love.graphics.newImage('klangbilder/Wolken1b.png')
bg03 = love.graphics.newImage('klangbilder/Wolken2.png')
bg01Scroll = 0
bg02Scroll = 0
bg03Scroll = 0


HG_SCROLL_TEMPO = 100

HG_LOOPING_POINT = 2402
Wolken1a_LOOPING_POINT = 2404

anim8 = require 'lib/anim8' 

push = require 'lib/push'

WINDOW_WIDTH = 1000
WINDOW_HEIGHT = 400

VIRTUAL_WIDTH = 500
VIRTUAL_HEIGHT = 200

function check_collision(x1,y1,w1,h1,   x2,y2,w2,h2)
    return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end

function love.load()

    love.graphics.setDefaultFilter('nearest', 'nearest')

    kaktus1 = love.graphics.newImage('klangbilder/Kakteen/Kaktee_1.1b.png')
    kaktus2 = love.graphics.newImage('klangbilder/Kakteen/Kaktee_1.2b.png')
    kaktus3 = love.graphics.newImage('klangbilder/Kakteen/Kaktee_1.3b.png')
    kaktus4 = love.graphics.newImage('klangbilder/Kakteen/Kaktee_1.4b.png')
    kaktus5 = love.graphics.newImage('klangbilder/Kakteen/Kaktee_2.1.png')
    kaktus6 = love.graphics.newImage('klangbilder/Kakteen/Kaktee_2.2.png')
    kaktus7 = love.graphics.newImage('klangbilder/Kakteen/Kaktee_2.3.png')
    vogel_kollision = love.graphics.newImage('klangbilder/Vogel_einzeln.png')

    spritesheet = love.graphics.newImage('klangbilder/T-rex_Lauf.png')
    spritesheet2 = love.graphics.newImage('klangbilder/T-rex_ducken.png')
    spritesheet3 = love.graphics.newImage('klangbilder/Vogel.png')

    gridWidth = 440/5
    gridWidth2 = 236/2
    gridWidth3 = 184/2

    gridHeight = 94
    gridHeight2 = 60
    gridHeight3 = 80

    my_grid = anim8.newGrid(gridWidth, gridHeight, spritesheet:getWidth(), spritesheet:getHeight())
    my_grid2 = anim8.newGrid(gridWidth2, gridHeight2, spritesheet2:getWidth(), spritesheet2:getHeight())
    my_grid3 = anim8.newGrid(gridWidth3, gridHeight3, spritesheet3:getWidth(), spritesheet3:getHeight())

    animations = {
        sprung = anim8.newAnimation(my_grid('1-1',1), 0.1, onLoop),
        laufen = anim8.newAnimation(my_grid('3-4',1), 0.1, onLoop),
        getroffen = anim8.newAnimation(my_grid('5-5',1), 0.1, onLoop),
        
        ducken = anim8.newAnimation(my_grid2('1-2',1), 0.1, onLoop),
        
        vogel = anim8.newAnimation(my_grid3('1-2',1), 0.5, onLoop),
    }

    actual_animation = animations.laufen

    player.zoom = 0.6
    player.bodenausgleich = 0.85
    player.transparenzausgleich = 0.6
    player.gridWidth = gridWidth * player.zoom
    player.gridHeight = gridHeight * player.zoom
    player.y = VIRTUAL_HEIGHT - player.gridHeight - 5
    player.boden = player.y
    player.boden_default = player.y
    player.y_tempo = 0
    player.sprunghoehe = -400
    player.gravitation = -1000

    push:setupScreen(VIRTUAL_WIDTH, VIRTUAL_HEIGHT, WINDOW_WIDTH, WINDOW_HEIGHT, {
        vsync = true,
        fullscreen = false,
        resizable = true
    })
end


function love.resize(w, h)
    push:resize(w, h)
end

function love.update(dt)

    if love.keyboard.isDown('escape') then
        love.event.push('quit')
    end

    if gamestate == "Menu" then
        if love.keyboard.isDown("space") then
            gamestate = "Game"
        end
    end

    if gamestate == "Game" then
        bg01Scroll = (bg01Scroll + (HG_SCROLL_TEMPO+120) * dt) % HG_LOOPING_POINT 
        bg02Scroll = (bg02Scroll + (HG_SCROLL_TEMPO+100) * dt) % Wolken1a_LOOPING_POINT 
        bg03Scroll = (bg03Scroll + (HG_SCROLL_TEMPO+ 85) * dt) % HG_LOOPING_POINT 
    
    
        spawnEnemyPause = spawnEnemyPause - (1 * dt)
    
        if spawnEnemyPause < 0 then
            spawnEnemyPause = math.random(spawnEnemyPauseMax, spawnEnemyPauseMax*4)
            neuerEnemy = {} 
            welcherKaktus = math.random(11) 
            if welcherKaktus == 1 then
                neuerEnemy.picture = kaktus1
                neuerEnemy.x = VIRTUAL_WIDTH + kaktus1:getWidth()
                neuerEnemy.y = VIRTUAL_HEIGHT - 0.5 * kaktus1:getHeight() + 5
            elseif welcherKaktus == 2 then
                neuerEnemy.picture = kaktus2
                neuerEnemy.x = VIRTUAL_WIDTH + kaktus2:getWidth()
                neuerEnemy.y = VIRTUAL_HEIGHT - 0.5 * kaktus2:getHeight() + 5
            elseif welcherKaktus == 3 then
                neuerEnemy.picture = kaktus3
                neuerEnemy.x = VIRTUAL_WIDTH + kaktus3:getWidth()
                neuerEnemy.y = VIRTUAL_HEIGHT - 0.5 * kaktus3:getHeight() + 5
            elseif welcherKaktus == 4 then
                neuerEnemy.picture = kaktus4
                neuerEnemy.x = VIRTUAL_WIDTH + kaktus4:getWidth()
                neuerEnemy.y = VIRTUAL_HEIGHT - 0.5 * kaktus4:getHeight() + 5
            elseif welcherKaktus == 5 then
                neuerEnemy.picture = kaktus5
                neuerEnemy.x = VIRTUAL_WIDTH + kaktus5:getWidth()
                neuerEnemy.y = VIRTUAL_HEIGHT - 0.5 * kaktus5:getHeight() 
            elseif welcherKaktus == 6 then
                neuerEnemy.picture = kaktus6
                neuerEnemy.x = VIRTUAL_WIDTH + kaktus6:getWidth()
                neuerEnemy.y = VIRTUAL_HEIGHT - 0.5 * kaktus6:getHeight() 
            elseif welcherKaktus == 7 then
                neuerEnemy.picture = kaktus7
                neuerEnemy.x = VIRTUAL_WIDTH + kaktus7:getWidth()
                neuerEnemy.y = VIRTUAL_HEIGHT - 0.5 * kaktus7:getHeight() 
            elseif welcherKaktus > 7 then
                neuerEnemy.isAnimated = true
                neuerEnemy.animation = animations.vogel
                neuerEnemy.picture = vogel_kollision
                neuerEnemy.x = VIRTUAL_WIDTH + spritesheet3:getWidth()/2
    
                hoehe = math.random(16)
                if hoehe < 4 then
                    neuerEnemy.y = 150
                elseif hoehe >= 4 and hoehe < 12 then
                    neuerEnemy.y = 125
                else
                    neuerEnemy.y = 100
                end
            end
    
            table.insert(allEnemies, neuerEnemy)
        end
    
        for i, enemy in ipairs(allEnemies) do
            enemy.x = enemy.x - (enemyTempo * dt)
    
            if enemy.x < (0 - enemy.picture:getWidth()) then 
                table.remove(allEnemies, i)
                score = score + 1 
            end
        end
    
        if love.keyboard.isDown('left','a') and player.y == player.boden then
            if player.x > 0 then 
                player.x = player.x - (player.tempo*dt)
            end
        elseif love.keyboard.isDown('right','d') and player.y == player.boden then
            if player.x < (love.graphics.getWidth() - player.gridWidth) then
                player.x = player.x + (player.tempo*dt)
            end
        end
    
        if player.y_tempo == 0 then 
            if love.keyboard.isDown('space','up') 
                and actual_animation ~= animations.ducken then 
                    player.y_tempo = player.sprunghoehe 
                    actual_animation = animations.sprung
            elseif love.keyboard.isDown('down') then 
                player.y = VIRTUAL_HEIGHT - gridHeight2 * player.zoom - 5
                player.boden = player.y
                actual_animation = animations.ducken
            else
                player.y = VIRTUAL_HEIGHT - gridHeight * player.zoom - 5
                player.boden = player.y
                actual_animation = animations.laufen
            end
        end
    
        if player.y_tempo ~= 0 then 
            player.y = player.y + player.y_tempo * dt 
            player.y_tempo = player.y_tempo - player.gravitation * dt 
        end
    
        if player.y > player.boden then 
            player.y_tempo = 0 
            player.y = player.boden 
            actual_animation = animations.laufen
        end
        
        actual_animation:update(dt)
        animations.vogel:update(dt)
    
        for i, enemy in ipairs(allEnemies) do
            if check_collision(
                    enemy.x+4, enemy.y+4, enemy.picture:getWidth()*enemyZoom-4, enemy.picture:getHeight()*enemyZoom-4,
                    player.x+15, player.y+4, player.gridWidth*player.transparenzausgleich-4, player.gridHeight-4
                    ) and isAlive then
                table.remove(allEnemies, i)
                actual_animation = animations.getroffen
                isAlive = false
                player.y = player.boden_default
                gamestate = "Game over"
            end
        end
    end 

    if gamestate == "Game over" then
        if not isAlive and love.keyboard.isDown('r') then
            allEnemies = {}
    
            spawnEnemyPause = spawnEnemyPauseMax
    
            player.x = 50
    
            score = 0
            isAlive = true
            gamestate = "Game"
        end
    end 

end

function love.draw()

    push:start()
    
    love.graphics.draw(bg02, -bg03Scroll, 20)
    love.graphics.draw(bg02, -bg02Scroll, 50)
    love.graphics.draw(bg01, -bg01Scroll, VIRTUAL_HEIGHT-bg01:getHeight())

    love.graphics.setColor(0, 0, 0)
    love.graphics.print("SCORE: " .. tostring(score), VIRTUAL_WIDTH/2, 10)
    
    if debug then
        fps = tostring(love.timer.getFPS())
        love.graphics.print("FPS: "..fps, 9, 10)
        love.graphics.print("player.x: "..player.x, 9, 25)
        love.graphics.print("player.y: "..player.y, 9, 40)
        love.graphics.print("gamestate: "..gamestate, 9, 55)
    end

    love.graphics.setColor(1, 1, 1)

    if gamestate == "Menu" then 
        love.graphics.setColor(0, 0, 0)
        love.graphics.print("Press 'space' to start the game!", VIRTUAL_WIDTH/2-50, VIRTUAL_HEIGHT/2-10)
        love.graphics.setColor(1, 1, 1)
    end
    
    for i, enemy in ipairs(allEnemies) do
        if enemy.isAnimated == true then
            animations.vogel:draw(spritesheet3, enemy.x, enemy.y, nil, enemyZoom, enemyZoom)
        else
            love.graphics.draw(enemy.picture, enemy.x, enemy.y, nil, enemyZoom, enemyZoom)
        end
    end

    if isAlive then
        if actual_animation == animations.ducken then
            actual_animation:draw(spritesheet2, player.x, player.y, nil, player.zoom, player.zoom)
        else
            actual_animation:draw(spritesheet, player.x, player.y, nil, player.zoom, player.zoom)
        end
    else
        actual_animation:draw(spritesheet, player.x, player.y, nil, player.zoom, player.zoom)
        love.graphics.setColor(0, 0, 0)
        love.graphics.print("Drücke 'r' für reset", VIRTUAL_WIDTH/2-50, VIRTUAL_HEIGHT/2-10)
        love.graphics.setColor(1, 1, 1)
    end

    push:finish()
    love.graphics.setBackgroundColor(1,1,1)
end
